
#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>

#define MOTOR_PORT PORTC
#define MOTOR_LEFT 0b10000001
#define MOTOR_RIGHT 0b01000010
#define MOTOR_FORWARD 0b01000001
#define MOTOR_BACKWARD 0b10000010
#define TURN_DELAY 2000


int ADC_get(uint8_t channel){
	ADMUX &= 0b11100000;
	ADMUX |= channel;
	ADCSRA |= _BV(ADSC);
	loop_until_bit_is_set(ADCSRA, ADIF);
	
	return ADC;
}

void ADC_init(void){
	
	ADMUX = _BV(REFS0);
	ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0);
}

int main(void){
   
   DDRA = 0x00;					 // portul A de intrare (senzorul)
   DDRC = 0xFF;                  // portul C de iesire (controlul motoarelor)

   MOTOR_PORT = MOTOR_FORWARD;	//merge inainte

   int distance = 1024;		//valoare initiala (debug)
   int threshold = 512;		//limita de distanta pt care robotul se intoarce 512 = 1024/2 = 5v /2 = 2.5v =(cf dataseet cca 10 cm)

	ADC_init();

	for(;;) {                     // Loop Forever
		
		// Get ADC the Result
		distance = ADC_get(0);

		if(distance > threshold){		//am obstacol in fata
			MOTOR_PORT = MOTOR_LEFT;	//rotesc robotul
			_delay_ms(TURN_DELAY);		//pentru TURN_DELAY milisecunde

		} else {
			MOTOR_PORT = MOTOR_FORWARD;	//altfel continui sa merg inainte
		}
	}
	return 0;	                    
}
